//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 四元数回転配列補間ヘッダ
 * @author Junpee
 */

#ifndef QUATERNION_ARRAY_INTERPOLATOR_H_
#define QUATERNION_ARRAY_INTERPOLATOR_H_

#include <Animation/RotationInterpolator/RotationInterpolator.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * 四元数回転配列補間
 */
class QuaternionArrayInterpolator : public RotationInterpolator{
public:
	//--------------------------------------------------------------------------
	/**
	 * コンストラクタ
	 */
	QuaternionArrayInterpolator();

	/**
	 * デストラクタ
	 */
	virtual ~QuaternionArrayInterpolator();

	/**
	 * コピーコンストラクタ
	 * @param copy コピー元
	 */
	explicit QuaternionArrayInterpolator(
		const QuaternionArrayInterpolator& copy);

	/**
	 * 代入演算子
	 * @param copy 代入元
	 */
	virtual QuaternionArrayInterpolator& operator =(
		const QuaternionArrayInterpolator& copy);

	//--------------------------------------------------------------------------
	/**
	 * 複製
	 * @return 複製されたオイラー回転補間。呼び出し元でdeleteする必要がある
	 */
	virtual RotationInterpolator* duplicate() const{
		RotationInterpolator* result =
			new QuaternionArrayInterpolator(*this);
		return result;
	}

	//--------------------------------------------------------------------------
	/**
	 * 同じ値かどうか
	 * @param target 比較対象
	 * @return 同じ値ならtrueをかえす
	 */
	virtual bool equals(const RotationInterpolator& target) const{
		QuaternionArrayInterpolator* interpolator =
			target.castQuaternionArrayInterpolator();
		if(interpolator == NULL){ return false; }
		if(size_ != interpolator->size_){ return false; }
		for(int i = 0; i < size_; i++){
			if(array_[i] != interpolator->array_[i]){ return false; }
		}
		return true;
	}

	//--------------------------------------------------------------------------
	/**
	 * 長さの取得
	 * @return 長さ
	 */
	virtual float getLength() const{ return length_; }

	//--------------------------------------------------------------------------
	// オイラー補間
	//--------------------------------------------------------------------------
	/**
	 * オイラー補間かどうか
	 * @return オイラー補間ならtrue
	 */
	virtual bool isEulerInterpolator() const{ return true; }

	/**
	 * オイラー補間
	 * @param time 時間
	 * @return 補間された回転
	 */
	virtual Vector3 eulerInterpolate(float time);

	//--------------------------------------------------------------------------
	// 四元数補間
	//--------------------------------------------------------------------------
	/**
	 * 四元数補間かどうか
	 * @return 四元数補間ならtrue
	 */
	virtual bool isQuaternionInterpolator() const{ return true; }

	/**
	 * 四元数補間
	 * @param time 時間
	 * @return 補間された回転
	 */
	virtual Quaternion quaternionInterpolate(float time);

	//--------------------------------------------------------------------------
	// 値
	//--------------------------------------------------------------------------
	/**
	 * サイズ設定
	 * @param size 設定するサイズ。サイズ - 1がLengthになる。
	 */
	virtual void setSize(int size);

	/**
	 * サイズ取得
	 * @return サイズ
	 */
	virtual int getSize() const{ return size_; }

	//--------------------------------------------------------------------------
	/**
	 * 値の設定
	 * @param index 設定する値のインデックス
	 * @param value 設定する値
	 */
	virtual void setValue(int index, const Quaternion& value);

	/**
	 * 値の補正
	 */
	virtual void correctValue();

	/**
	 * 値の取得
	 * @param index 取得する値のインデックス
	 * @return 値
	 */
	virtual const Quaternion& getValue(int index) const{
		Assert(array_ != NULL);
		Assert(index >= 0);
		Assert(index < size_);
		return array_[index];
	}

	//--------------------------------------------------------------------------
	// 変換
	//--------------------------------------------------------------------------
	/**
	 * オイラー回転配列補間への変換
	 * @return オイラー回転配列補間、呼び出し元で破棄する必要がある
	 */
	EulerArrayInterpolator* convertEulerArrayInterpolator() const;

	//--------------------------------------------------------------------------
	// RTTI
	//--------------------------------------------------------------------------
	/**
	 * 四元数回転配列補間かどうか
	 * @return 四元数回転配列補間ならtrue
	 */
	virtual bool isQuaternionArrayInterpolator() const{ return true; }

	//--------------------------------------------------------------------------
private:
	// 配列
	Quaternion* array_;
	// サイズ
	int size_;
	// 長さ
	float length_;

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of QUATERNION_ARRAY_INTERPOLATOR_H_
//------------------------------------------------------------------------------

